=begin
Copyright 2015 The MITRE Corporation

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=end

require_relative "tagger.rb"

class ListTagger < Tagger
    def parse_text(text, precondition, search, content_group = @content_group)
        tags = []
        content_group = 1
        @list.each do |form|
            if text =~ form
                precondition = form
                search = /(\b#{form})/i
                tags += super text, precondition, search, content_group
            end
        end
        return tags
    end

    def parse_main(text)
        return parse_text(text, @default_precondition, @default_search, @content_group)
    end
end
