# coding: utf-8
=begin
Copyright 2015 The MITRE Corporation.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
zlimitations under the License.”
=end

class DoseFormTagger < ListTagger
    def initialize
        @name = 'doseform'
        @list = [/(?:micro )?neb(?:ulizer)?s?/i,
                /(?:(?:powdered|metered)(?:\s+|\-)dose\s+)?inhalers?/i,
                /bar\b/i,
                /beads/i,
                /cake/i,
                /caplets?/i,
                /capsules?/i,
                /cement/i,
                /chewable bars?/i,
                /(?:(?:chewable|disintegrating)\s+)?tab(?:let)?s?/i,
                /chewing gum/i,
                /cream/i,
                /crystals/i,
                /disk(?:us)?\b/i,
                /douche/i,
                /drops?/i,
                /drug implant/i,
                /dry powder inhaler/i,
                /enema/i,
                /enteric coated capsule/i,
                /enteric coated tablet/i,
                /extended release capsules?/i,
                /extended release enteric coated capsules?/i,
                /extended release enteric coated tablets?/i,
                /extended release suspension/i,
                /extended release tablets?/i,
                /flakes/i,
                /foam/i,
                /gas for inhalation/i,
                /gel/i,
                /granules/i,
                /gtts?/i,
                /inhalant(?:\s+powder|solution)?/i,
                /injectable solution/i,
                /injectable suspension/i,
                /intraperitoneal solution/i,
                /irrigation solution/i,
                /jelly/i,
                /liniment/i,
                /liquid/i,
                /liquid cleanser/i,
                /lotion/i,
                /lozenges?/i,
                /(?:medicated\s+)?(?:bar|liquid)\s+soap/i,
                /medicated pad/i,
                /medicated shampoo/i,
                /medicated swab/i,
                /medicated tape/i,
                /mouthwash/i,
                /oil/i,
                /ointment/i,
                /paste/i,
                /patch/i,
                /pellets?/i,
                /pills?/i,
                /powder/i,
                /prefilled applicator/i,
                /prefilled syringe/i,
                /pudding/i,
                /rinse/i,
                /solid/i,
                /solution/i,
                /sprays?/i,
                /strip/i,
                /suppository/i,
                /suspension/i,
                /sustained release buccal tablets?/i,
                /syrup/i,
                /tincture/i,
                /toothpaste/i,
                /troche/i,
                /wafers?/i]
    end
end
