=begin
Copyright 2015 The MITRE Corporation

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=end

class RouteTagger < ListTagger
    def initialize
        @name = 'route'
        @list = [/ORAL(?:ly)?/i,
                /p\.o\./i,
                /po\b/i,
                /by\s+mouth/i,
                /per\s+(?:oris|rectum|nostril|mouth)/i,
                /INTRAVENOUS(?:ly)?/i,
                /SUBCU(?:TANEOUS(?:ly)?)?/i,
                /subq\.?/i,
                /INTRAPERITONEAL(?:ly)?/i,
                /INTRAMUSCULAR(?:ly)?/i,
                /INTRATHORACIC/i,
                /INTRA-ARTICULAR(?:ly)?/i,
                /INTRADERMAL(?:ly)?/i,
                /EPIDURAL(?:ly)?/i,
                /INTRASINAL(?:ly)?/i,
                /TOPICAL(?:ly)?/i,
                /AURICULAR(?:ly)?/i,
                /OTIC/i,
                /((?:right|left|both)\s+)?ears?/i,
                /NASAL(?:ly)?/i,
                /nose/i,
                /opthalimic/i,
                /eyes?/i,
                /VAGINAL(?:ly)?/i,
                /RECTAL (?:ly)?/i,
                /URETHRAL(?:ly)?/i,
                /INHALATION/i,
                /INTRASYNOVIAL(?:ly)?/i,
                /INTRATUMOR/i,
                /INTRAVASCULAR(?:ly)?/i,
                /INTRASPINAL(?:ly)?/i,
                /INTRACAVITARY/i,
                /SUBLINGUAL(?:ly)?/i,
                /INTRABURSAL/i,
                /INTRACARDIAC/i,
                /INTRAUTERINE/i,
                /CAUDAL BLOCK/i,
                /BUCCAL(?:ly)?/i,
                /CNBLK/i,
                /INTRATHECAL(?:ly)?/i,
                /RETROBULBAR/i,
                /INTRATRACHEAL(?:ly)?/i,
                /INTRAOCULAR(?:ly)?/i,
                /INTRA-ARTERIAL(?:ly)?/i,
                /DENTAL(?:ly)?/i,
                /PERIODONTAL(?:ly)?/i,
                /IMPLANTATION/i,
                /INTRALESIONAL/i,
                /INTRAPLEURAL/i,
                /PERIARTICULAR/i,
                /INTRAGASTRIC/i,
                /INTRADUODENAL/i,
                /INTRAVENTRICULAR/i,
                /INTRATENDINOUS/i,
                /PERIDURAL/i,
                /INTRACERVICAL/i,
                /INTRADURAL/i,
                /SUBMUCOSAL/i,
                /VOCAL CORDS/i,
                /INTRA-ABDOMINAL/i,
                /EXTRACORPOREAL/i,
                /NERVE BLOCK/i,
                /INTRA-AMNIOTIC/i,
                /INTRAPROSTATIC/i,
                /INVITRO/i,
                /SUBARACHNOID/i,
                /INTRABRONCHIAL/i,
                /CONJUNCTIVAL/i,
                /NASOGASTRIC/i,
                /INTRAESOPHAGEAL/i,
                /INTERSTITIAL/i,
                /IV\b/i,
                /IM\b/i,
                /SUBCONJUNCTIVAL/i,
                /SURGICAL/i,
                /AN,INFILTRATION/i,
                /AN,SURFACE/i,
                /INTRATHECAL/i,
                /ORAL-21/i,
                /ORAL-28/i,
                /ORAL-20/i,
                /BUCCAL\/SUBLINGUAL/i,
                /SOFT TISSUE/i,
                /INTRATESTICULAR/i,
                /URETERAL/i,
                /PERCUTANEOUS/i,
                /S(?:C|Q)\b/i,
                /INFUSION/i,
                /INHALATION, NASAL/i,
                /PERFUSION/i,
                /INTRACORONAL, DENTAL/i,
                /PERFUSION\/CARDIAC/i,
                /INTRACORONARY/i,
                /ENDOCAVITARY/i,
                /INTRADISCAL/i,
                /(?:TRANS)?MUCOSAL/i,
                /mucous membrane/i,
                /INTRADUCTAL/i,
                /TRANSTYMPANIC/i,
                /PERFUSION, BILIARY/i,
                /INTRAEPIDERMAL/i,
                /INTRAGINGIVAL/i,
                /INTRALUMINAL/i,
                /INTRAVITREAL/i,
                /ENTERAL/i,
                /INTRAPERICARDIAL/i,
                /INTRALYMPHATIC/i,
                /INTRATUBULAR/i,
                /INTRAOVARIAN/i,
                /TRANSTRACHEAL/i,
                /SPINAL/i,
                /ELECTRO-OSMOSIS/i,
                /(?:TRANS)?DERMAL/i,
                /PHOTOPHERESIS/i,
                /THROAT/i,
                /INFILTRATION/i,
                /INTRABILIARY/i,
                /INTRACARTILAGINOUS/i,
                /UNASSIGNED/i,
                /LARYNGEAL/i,
                /INTRAILEAL/i,
                /IRRIGATION/i,
                /IONTOPHORESIS/i,
                /AN,SYMPATHETIC NBLK/i,
                /INTRAVESICAL/i,
                /INTRAVESICAL/i,
                /INTRATYMPANIC/i,
                /ENDOTRACHEAL/i,
                /EXTRA-AMNIOTIC/i,
                /INTRACORPORUS CAVERNOSUM/i,
                /INTRACEREBRAL/i,
                /INTRACISTERNAL/i,
                /INTRACORNEAL/i,
                /INTRAMEDULLARY/i,
                /INTRAMENINGEAL/i,
                /OROPHARYNGEAL/i,
                /PARENTERAL/i,
                /PERINEURAL/i,
                /INTRACAUDAL/i,
                /INTRAPULMONARY/i,
                /AURICULAR/i,
                /(?:SUB-)?CUTANEOUS/i,
                /ENDOCERVICAL/i,
                /INTRACAVERNOUS/i,
                /ENDOSINUSIAL/i,
                /OCCLUSIVE DRESSING TECHNIQUE/i,
                /RESPIRATORY/i,
                /INTRAVENOUS DRIP/i,
                /INTRAVENOUS BOLUS/i,
                /HEMODIALYSIS/i,
                /TRANSPLACENTAL/i,
                /INTRAEPICARDIAL/i,
                /INTRAHEPATIC/i,
                /INTRALINGUAL/i,
                /INTRAMAMMARY/i,
                /INTRANODAL/i,
                /INTRAOMENTUM/i,
                /INTRARUMINAL/i,
                /SUBGINGIVAL/i,
                /SUBRETINAL/i,
                /TRANSENDOCARDIAL/i,
                /OPHTHALMIC/i,
                /\b(?:OD|OS)\b/i,
                /apply\s+to\s+(?:skin|affected\s+areas?)/i]
    end
end
