=begin
Copyright 2015 The MITRE Corporation

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=end

class IndicationTagger < Tagger
    def initialize
        @shared_search = /(?x)(?:(?:(?:severe|high|hyper|hypo|low)\s*)?
                  (?:(?:chest\s+)?pain|cholesterol(?:emia)
                  |constipation|allergic\s+rhinitis|allergy|anxiety|bone\s+
                  loss|indigestion|headache|nausea|osteoporosis|wheez
                  (?:e|ing)|edema|discomfort|itch(?:ing)?|c\.?\s*diff))/i
        @default_precondition = /#{@shared_search}/i
        @default_search = /(?x)((?:p\.?r\.?n\.?|(?:as\s+needed\s+)?
                        for|prevention\s+of)\s+)(#{@shared_search})/i
        @content_group = 2
        @name = 'indication'
    end
end
